#ifndef _DISPLAY_H_
#define _DISPLAY_H_

#include <stdlib.h>

typedef enum {
    GCMD_CLEAR,
    GCMD_HSCROLL,
    GCMD_VSCROLL,
    GCMD_BITBLT,
    GCMD_DRAWBITMAP,
    GCMD_SETPIXEL,
    GCMD_DRAWLINE,
    GCMD_DRAWCIRCLE,
    GCMD_DRAWRECT,
    GCMD_PUTCHR,
    GCMD_PUTSTR,
} gcmd;

typedef struct {
    uint8_t x;
    uint8_t y;
} coord;

typedef struct {
    uint8_t left, right, top, bottom;
} rect;

typedef struct {
    uint8_t width, height;
    uint8_t data[1];
} gbmp;

typedef struct {
    gcmd c;
    void *params;
} gparam;



extern uint8_t display_buffer[];
void display(void);
void display_putchar(char c, uint8_t col_x, uint8_t col_y, bool reverse);
void display_putstr(char *str, uint8_t col_x, uint8_t col_y, bool reverse);

#endif
